package milab.lab04.DoctorAgent;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import milab.lab04.DoctorAgent.DoctorAgent;

// GUI of Bayes-Network reasoning JADE agent (c) Kovcs Dniel Lszl [dkovacs@mit.bme.hu]
class DoctorAgentGui extends JFrame {

	private DoctorAgent myAgent;

	private JCheckBox[] symptomsChoice;

	DoctorAgentGui(DoctorAgent a) {

		super(a.getLocalName());

		myAgent = a;

		JPanel p = new JPanel();
		p.setLayout(new GridLayout(myAgent.symptomIDs.length, 1));

		// Memory reservation...
		symptomsChoice	= new JCheckBox[myAgent.symptomIDs.length];

		// Ready up the JPanel in this JFrame
		for (int i = 0; i < myAgent.symptomIDs.length; i++) {
	
			symptomsChoice[i] = new JCheckBox(myAgent.symptomIDs[i], true);
			symptomsChoice[i].addItemListener(new JCheckBoxItemListener(i));
			p.add(symptomsChoice[i]);

		}

		p.setBorder(BorderFactory.createTitledBorder("Used symptoms"));
		getContentPane().add(p, BorderLayout.CENTER);

		// Make the agent terminate when the user closes 
		// the GUI using the button on the upper right corner	
		addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent e) {

				myAgent.doDelete();

			}

		});

		setResizable(false);

	} // End of DoctorAgentGui's constructor

	private class JCheckBoxItemListener implements ItemListener {

		final int i;

		JCheckBoxItemListener(int input) {

			i = input;

		}

		public void itemStateChanged(ItemEvent ie) {

			// JCheckBox cb = (JCheckBox)ie.getItem();
			int state = ie.getStateChange();

			if (state == ItemEvent.SELECTED) {
	
				myAgent.symptomIDsSelection[i] = true;

			} else {

				myAgent.symptomIDsSelection[i] = false;

			}

		} // End of method DoctorAgentGui.JCheckBoxItemListener.itemStateChanged

	} // End of inner class DoctorAgentGui.JCheckBoxItemListener

	public void show() {

		pack();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		int centerX = (int)screenSize.getWidth() / 2;
		int centerY = (int)screenSize.getHeight() / 2;
		setLocation(centerX - getWidth() / 2, centerY - getHeight() / 2);
		super.show();

	} // End of method DoctorAgentGui.show()

} // End of class DoctorAgentGui
